//TODO: introduce mocking
import 'package:cramr_ui_lib/model/verb_test_model.dart';
import 'package:cramr_ui_lib/routes/verb_indicative_study_route.dart';
import 'package:flutter/material.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:provider/provider.dart';

final List<String> _randomIndicative = [
  'exp1',
  'exp2',
  'exp3',
  'exp4',
  'exp5',
  'exp6',
];

final List<String> _randomPronouns = [
  'pron1',
  'pron2',
  'pron3',
  'pron4',
  'pron5',
  'pron6',
];

final String _randomInfinitive = 'infinitive';

void main() {
  testWidgets('Testing for the presence of covered buttons',
      (WidgetTester tester) async {
    await tester.pumpWidget(ChangeNotifierProvider(
      create: (BuildContext context) {
        var model = VerbTestModel();
        model.initialise(_randomIndicative, _randomPronouns, 'fr',
            _randomInfinitive, 'translation');
        return model;
      },
      child: VerbIndicativeStudyRoute(StudyMode.coverMode),
    ));
    for (int i = 0; i < 6; i++) {
      // Make sure that we cannot read the indicative yet
      final Finder indicativeFinder = find.text(_randomIndicative[i]);
      expect(indicativeFinder, findsNothing);

      // Check if we can find the cover
      final Finder coverFinder =
          find.byKey(Key('cover_${_randomInfinitive}_${i}'));
      expect(coverFinder, findsOneWidget);

      // Make sure that we can read the indicative after tapping it
      await tester.tap(coverFinder);
      await tester.pump();
      expect(indicativeFinder, findsOneWidget);
    }
  });
}
