import 'package:cramr_ui_lib/model/verb_test_model.dart';
import 'package:cramr_ui_lib/routes/verb_indicative_study_route.dart';
import 'package:flutter/material.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:provider/provider.dart';

final List<String> _randomIndicative = [
  'exp1',
  'exp2',
  'exp3',
  'exp4',
  'exp5',
  'exp6',
];

final List<String> _randomPronouns = [
  'pron1',
  'pron2',
  'pron3',
  'pron4',
  'pron5',
  'pron6',
];

final String _randomInfinitive = 'infinitive';
final Finder sliderFinder = find.byKey(Key('flashcard_slider'));
final Finder playButtonFinder = find.byKey(Key('PlayButton'));

void main() {
  testWidgets('Test the flashcard mode study screen',
      (WidgetTester tester) async {
    await tester.pumpWidget(ChangeNotifierProvider(
      create: (BuildContext context) {
        var model = VerbTestModel();
        model.initialise(_randomIndicative, _randomPronouns, 'fr',
            _randomInfinitive, 'translation');
        return model;
      },
      child: VerbIndicativeStudyRoute(StudyMode.flashCardMode),
    ));
    Finder findFirstIndicative = find.text(_randomIndicative[0]);
    expect(findFirstIndicative, findsOneWidget);
    expect(sliderFinder, findsOneWidget);
    expect(playButtonFinder, findsOneWidget);
  });
}
