//TODO: introduce mocking
import 'package:cramr_ui_lib/model/verb_test_model.dart';
import 'package:cramr_ui_lib/routes/verb_indicative_study_route.dart';
import 'package:cramr_ui_lib/routes/verb_indicative_test_route.dart';
import 'package:flutter/material.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:provider/provider.dart';

import 'verb_indicative_study_write_mode_form_state_test.dart';

final List<String> _randomIndicative = [
  'exp1',
  'exp2',
  'exp3',
  'exp4',
  'exp5',
  'exp6',
];

final List<String> _randomPronouns = [
  'pron1',
  'pron2',
  'pron3',
  'pron4',
  'pron5',
  'pron6',
];

final String _randomInfinitive = 'infinitive';

void main() {
  testWidgets(
      'Testing for presence of fields and forward button. Some logic too.',
      (WidgetTester tester) async {
    await tester.pumpWidget(ChangeNotifierProvider(
      create: (BuildContext context) {
        var model = VerbTestModel();
        model.initialise(_randomIndicative, _randomPronouns, 'fr',
            _randomInfinitive, 'translation');
        return model;
      },
      child: VerbIndicativeTestRoute(StudyMode.coverMode),
    ));
    Finder titleFinder = find.text('Vervoeging ${_randomInfinitive}');
    expect(titleFinder, findsOneWidget);
    Finder forwardButtonFinder =
        find.byKey(Key('evaluate_${_randomInfinitive}'));
    expect(forwardButtonFinder, findsOneWidget);
    await tester.tap(forwardButtonFinder);
    await tester.pumpAndSettle();
    expect(titleFinder, findsOneWidget);
    int i = 0;
    _randomIndicative.forEach((element) async* {
      final Finder textFieldFinder =
          find.byKey(Key('test_${_randomInfinitive}_${i}'));
      expect(textFieldFinder, findsOneWidget);
      await tester.enterText(textFieldFinder, element);
      await tester.pumpAndSettle();
      i++;
    });
  });
}
