import 'dart:collection';

import 'package:cramr_ui_lib/model/verb.dart';
import 'package:cramr_ui_lib/repo/verb_repository.dart';
import 'package:cramr_ui_lib/routes/verb_selection_route.dart';
import 'package:flutter/material.dart';
import 'package:flutter_test/flutter_test.dart';

void main() {
  testWidgets('Test whether all verbs from the repository get filled in',
      (WidgetTester tester) async {
    List<String> pronouns = ['', '', '', '', '', ''];
    Verb verb1 = Verb(
        'infinitive1',
        'translation1',
        [
          'singular1',
          'singular2',
          'singular3',
          'plural1',
          'plural2',
          'plural3'
        ],
        "fr");
    Verb verb2 = Verb(
        'infinitive2',
        'translation2',
        [
          'singular1',
          'singular2',
          'singular3',
          'plural1',
          'plural2',
          'plural3'
        ],
        "fr");
    Verb verb3 = Verb(
        'infinitive3',
        'translation3',
        [
          'singular1',
          'singular2',
          'singular3',
          'plural1',
          'plural2',
          'plural3'
        ],
        "fr");
    HashMap<String, Verb> verbs = HashMap();
    verbs[verb1.infinitive] = verb1;
    verbs[verb2.infinitive] = verb2;
    verbs[verb3.infinitive] = verb3;
    VerbRepository.instance().initialise(verbs, pronouns);

    await tester.pumpWidget(VerbSelectionRoute());
    // Go through verbs
    VerbRepository.instance().verbs.forEach((key, value) {
      Finder infinitiveFinder = find.text(key);
      expect(infinitiveFinder, findsOneWidget);
      Finder translationFinder = find.text(value.translation);
      expect(translationFinder, findsOneWidget);
      Finder buttonFinder = find.byKey(Key('vervoeg ${key}'));
    });
  });
}
