import 'package:cramr_ui_lib/model/verb_test_model.dart';
import 'package:cramr_ui_lib/routes/verb_studymode_selection_route.dart';
import 'package:flutter/material.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:provider/provider.dart';

final List<String> _randomIndicative = [
  'exp1',
  'exp2',
  'exp3',
  'exp4',
  'exp5',
  'exp6',
];

final List<String> _randomPronouns = [
  'pron1',
  'pron2',
  'pron3',
  'pron4',
  'pron5'
      'pron6',
];

void main() {
  testWidgets('Test the selection of the study mode',
      (WidgetTester tester) async {
    await tester.pumpWidget(ChangeNotifierProvider(
      create: (BuildContext context) {
        var model = VerbTestModel();
        model.initialise(_randomIndicative, _randomPronouns, 'fr', 'infinitive',
            'translation');
        return model;
      },
      child: VerbStudymodeSelectionRoute(),
    ));
    Finder coverModeButtonFinder = find.byKey(Key('buttonCoverMode'));
    expect(coverModeButtonFinder, findsOneWidget);
    Finder flashModeButtonFinder = find.byKey(Key('buttonFlashCardMode'));
    expect(flashModeButtonFinder, findsOneWidget);
    Finder writeModeButtonFinder = find.byKey(Key('buttonWriteMode'));
    expect(writeModeButtonFinder, findsOneWidget);
  });
}
